<?php

/**
 * Class login
 *
 * handles the user login/logout/session
 * @author Panique
 * @link http://www.php-login.net
 * @link https://github.com/panique/php-login/
 * @license http://opensource.org/licenses/MIT MIT License
 */
class callBack
{

    private $db_connection = null;
    /**
     * @var string The user's name
     */
    
    public $errors = array();
    /**
     * @var array Collection of success / neutral messages
     */
    public $messages = array();
    
    public $depts = array();
    
    public $agents = array();

    /**
     * the function "__construct()" automatically starts whenever an object of this class is created,
     * 
     */
    public function __construct()
    {

	$this->databaseConnection();

	$agents = $this->createAgentList();

	
	$depts['emergency']['deptname']='emergency';
	$depts['emergency']['deptfullname']='Emergency';
	
	$depts['accounts']['deptname']='accounts';
	$depts['accounts']['deptfullname']='Accounts';
	
	$depts['sales']['deptname']='sales';
	$depts['sales']['deptfullname']='Sales';
	$this->depts = $depts;
	$this->agents = $agents;
	
    }

    /**
     creates DB connection if required
    */

    private function databaseConnection()
    {
        // connection already opened
        if ($this->db_connection != null) {
            return true;
        } else {
            try {
                $this->db_connection = new mysqli('91.216.241.100', 'callback_dbusr',  'tabJV?IPK5Va','callback_db');
                return true;
            } catch (PDOException $e) {
                $this->errors[] = 'Database error' . $e->getMessage();
                print_r($e->getMessage());
                return false;
            }
        }
    }
    

    /**
     run query, return object
     returns object
    */
     
    public function runSqlQuery($query)
    {
        // if database connection opened
        if ($this->databaseConnection()) {
			$sth = $this->db_connection->prepare($query);
			$sth->execute();
            return $sth;
        } else {
            return false;
        }
    }
    
    public function runSqlQuerytype2($query)
    {
        // if database connection opened
        if ($this->databaseConnection()) {
			$sth = $this->db_connection->query($query);
			//$sth->execute();
            return $sth;
        } else {
            return false;
        }
    }
    
    public function runSqlQueryreturn($query)
    {
        // if database connection opened
        if ($this->databaseConnection()) {
			$sth = $this->db_connection->query($query);
			
            return $sth;
        } else {
            return false;
        }
    }
    /**
     Create new callback
     Returns insertid (callbackid)
    */
    public function createNewCallBack($options)
    {
    	/*
    	$options['timestamp'] = time();
    	$options['status'] = 'status';
    	$options['userhash'] = aabbbcc;
    	$options['user_name'] = ;
    	$options['dept'] = ;
    	$options['contact_name'] = ;
    	$options['contact_num1'] = ;
    	$options['contact_num2'] = ;
    	$options['title'] = ;
    	$options['notes'] = ;
    	$options['transferids_prev'] = ;
    	$options['transfered_toid'] = ;
    	$options['created_by'] = ;
    	*/
    	if(!isset($options['timestamp'])){
    		$options['timestamp'] == '';
    	}
    	if(!isset($options['status'])){
    		$options['status'] == '';
    	}
    	if(!isset($options['userhash'])){
    		$options['userhash'] == '';
    	}
    	if(!isset($options['dept'])){
    		$options['dept'] == '';
    	}
    	if(!isset($options['contact_name'])){
    		$options['contact_name'] == '';
    	}
    	if(!isset($options['contact_num1'])){
    		$options['contact_num1'] == '';
    	}
    	if(!isset($options['contact_num2'])){
    		$options['contact_num2'] == '';
    	}
    	if(!isset($options['title'])){
    		$options['title'] == '';
    	}
    	if(!isset($options['notes'])){
    		$options['notes'] == '';
    	}
    	if(!isset($options['transferids_prev'])){
    		$options['transferids_prev'] == '';
    	}
    	if(!isset($options['transfered_toid'])){
    		$options['transfered_toid'] == '';
    	}
    	if(!isset($options['created_by'])){
    		$options['created_by'] == '';
    	}
    	
    	$query = "INSERT INTO `callback_db`.`callbacks` (`timestamp`, `status`, `userhash`, `user_name`, `dept`, `contact_name`, `contact_num1`, `contact_num2`, `title`, `notes`, `transferids_prev`, `transfered_toid`, `created_by`) 
VALUES ('".$options['timestamp']."', '".$options['status']."', '".$options['userhash']."', '".$options['user_name']."', '".$options['dept']."', '".$options['contact_name']."', '".$options['contact_num1']."', '".$options['contact_num2']."', '".$options['title']."', '".$options['notes']."', '".$options['transferids_prev']."', '".$options['transfered_toid']."', '".$options['created_by']."') ;";
    	//print_r($query);
    	$result = $this->runSqlQuery($query);
    	//print_r($result);
    	return $result;
    }
    
    public function getCallbacksfromdb($where)
    {
    	$query = 'SELECT * FROM callback_db.callbacks '.$where.';';
    	//echo $query;
    	$result = $this->runSqlQueryreturn($query);
    	if($result->num_rows == 0){
    	return array();
    	}
		while ($row = $result->fetch_object()){
     	   $array[] = (array)$row;
		}
    	return $array;
    }
    
    public function getActiveCallBacksFromDbWhereUsernameIs($username)
    {
    	$username = $this->db_connection->real_escape_string($username);
    	$where = 'Where `user_name` = "'.$username.'" and `status` = "active" order by timestamp asc';
    	$return = $this->getCallbacksfromdb($where);
    	
    	return $return;
    }
    
    public function getActiveCallBacksFromDB()
    {
    	$where = 'Where `status` = "active" order by timestamp asc';
    	$return = $this->getCallbacksfromdb($where);
    	
    	return $return;
    }
    
	public function getActiveCallBacksFromDbWhereUserHashIs($userhash)
    {

    	$userhash = $this->db_connection->real_escape_string($userhash);
    	$where = 'Where `userhash` = "'.$userhash.'" and `status` = "active" order by timestamp asc';
    	$return = $this->getCallbacksfromdb($where);

    	return $return ;
    }
    
    public function getCallbackById($id)
    {
    	$where = 'where id = "'.$id.'";';
    	$return = $this->getCallbacksfromdb($where);

    	return $return;
    }
    
    public function updateCallbackInDbById($id,$status,$notes,$transfered_toid)
    {
    	
    	$sql = "UPDATE `callback_db`.`callbacks` SET `status`='".$status."', `notes`='".$notes."', `transfered_toid`='".$transfered_toid."' WHERE `id`='".$id."';";
    	$return = $this->runSqlQuery($sql);
    	
    	return $return ;
    	
    }
    
    private function sendEmail($to, $title, $content)
    {
    	$to      = $to;
		$subject = $title;
		$message = $content;
		// To send HTML mail, the Content-type header must be set
		$headers  = 'MIME-Version: 1.0' . "\r\n";
		$headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
		$headers .= 'From: callback@hostireland.com' . "\r\n" .
    	'Reply-To: noreply@hostireland.com' . "\r\n";
		mail($to, $subject, $message, $headers);
    }
    
    public function sendNewCallbackEmail($options)
    {
    	$options['user_email']=$this->agents[$options['user_name']]['email'];
    	$title = 'New callback from '.$options['contact_name'];
    	$content = '
<html>Hi '.$this->agents[$options['user_name']]['fullname'].',<br><br>
You have a new callback request from '.$options['contact_name'].'<br>
Please contact them and update below<br>
Contact Number: '.$options["contact_num1"].'<br>
Notes: '.nl2br($options["notes"]).'<br><br>

<a href="http://callback.hostireland.com/callback.php?do=update&userhash='.$options['userhash'].'&id='.$options['insert_id'].'&status=contacted">Completed Callback</a><br>
<a href="http://callback.hostireland.com/callback.php?do=view&userhash='.$options['userhash'].'">View all my Callbacks</a><br>
</html>';
    	$this->sendEmail($options['user_email'], $title, $content);
    }
    
    public function sendNudgeEmail($options)
    {
    	$options['user_email']=$this->agents[$options['user_name']]['email'];
    	$title = 'Nudge about callback to '.$options['contact_name'];
    	$content = '
<html>Hi '.$this->agents[$options['user_name']]['fullname'].',<br><br>
You have a nudge to callback '.$options['contact_name'].'<br>
Please contact them and update below<br>
Contact Number: '.$options["contact_num1"].'<br>
Notes: '.nl2br($options["notes"]).'<br><br>

<a href="http://callback.hostireland.com/callback.php?do=update&userhash='.$options['userhash'].'&id='.$options['id'].'&status=contacted">Completed Callback</a><br>
<a href="http://callback.hostireland.com/callback.php?do=view&userhash='.$options['userhash'].'">View all my Callbacks</a><br>
</html>';
    	$this->sendEmail($options['user_email'], $title, $content);
    }
    
    private function getAgentListFromDB()
    {
    	$sql = "SELECT * FROM callback_db.users ORDER BY 0+username asc, username asc ;";
    	$result = $this->runSqlQueryreturn($sql);
    	if($result->num_rows == 0){
    	return array();
    	}
		while ($row = $result->fetch_object()){
     	   $array[] = (array)$row;
		}
    	return $array;
    }
    
    public function createAgentList()
    {
    	$array = $this->getAgentListFromDB();
    	foreach ($array as $user){
    		$agents[$user['username']]['user_name']=$user['username'];
			$agents[$user['username']]['fullname']=$user['fullname'];
			$agents[$user['username']]['email']=$user['useremail'];
			$agents[$user['username']]['userhash']=$user['userhash'];
			
    	}
    	//print_r($agents);
    	return $agents;
    }
    
    public function markCallbackAsCompleted($id)
    {
    	$time = time();
    	$sql = "UPDATE `callback_db`.`callbacks` SET `status`='completed',`completedat`='".$time."' WHERE `id`='".$id."';";
    	//echo $sql;
    	$return = $this->runSqlQueryreturn($sql);
    	
    	return $return ;
    	
    }
    
    public function getActiveCallBacksFromDbWhereCreatorUsernameIs($username)
    {
    	$username = $this->db_connection->real_escape_string($username);
    	$where = 'Where `created_by` = "'.$username.'" and `status` = "active" order by timestamp asc';
    	$return = $this->getCallbacksfromdb($where);
    	
    	return $return;
    }
    
    public function nudgeAgentAboutCallback($callbackid) // sends reminder email to agent
    {
    	$callback = $this->getCallbackById($callbackid);
    	if(isset($callback[0])){
    		$options = $callback[0];
			$this->sendNudgeEmail($options);
			header('Location: callback.php');
			return 1;
		} else { 
            return 0;
        }
    	

    	
    }
    
    public function getCallbacksCreatedBetween($time1, $time2)
    {
        $sql = 'where timestamp between "'.$time1.'" and "'.$time2.'";';
        return $this->getCallbacksfromdb($sql);
        
    }

    public function getCallbacksCompletedBetween($time1, $time2)
    {
        $sql = 'where completedat between "'.$time1.'" and "'.$time2.'";';
        return $this->getCallbacksfromdb($sql);
        
    }
    
}