<?php

/**
 * 
 * MODIFIED BY JAMIE!!!! - Don't replace'
 * Class login
 *
 * handles the user login/logout/session
 * @author Panique
 * @link http://www.php-login.net
 * @link https://github.com/panique/php-login/
 * @license http://opensource.org/licenses/MIT MIT License
 */
class Login
{
	private $salt = 'nWfvfDuCG9jQqQkPqz';
    /**
     * @var object The database connection
     */
    private $db_connection = null;
    /**
     * @var string The user's name
     */
    private $user_name = "";
    /**
     * @var int $user_id The user's id
     */
    private $user_id = null;
    /**
     * @var string The user's mail
     */
    private $user_email = "";
    /**
     * @var string $user_gravatar_image_url The user's gravatar profile pic url (or a default one)
     */
    public $user_gravatar_image_url = "";
    /**
     * @var string $user_gravatar_image_tag The user's gravatar profile pic url with <img ... /> around
     */
    public $user_gravatar_image_tag = "";
    /**
     * @var boolean $password_reset_link_is_valid Marker for view handling
     */
    private $password_reset_link_is_valid  = false;
    /**
     * @var boolean $password_reset_was_successful Marker for view handling
     */
    private $password_reset_was_successful = false;
    /**
     * @var array $errors Collection of error messages
     */
    /**
     * @var string The user's password hash
     */
    private $user_password_hash = "";
    /**
     * @var boolean The user's login status
     */
    private $user_is_logged_in = false;
    /**
     * @var array Collection of error messages
     */
    public $errors = array();
    /**
     * @var array Collection of success / neutral messages
     */
    public $messages = array();

    /**
     * the function "__construct()" automatically starts whenever an object of this class is created,
     * you know, when you do "$login = new Login();"
     */
    public function __construct()
    {
        define("COOKIE_RUNTIME", 12096000);
        define("COOKIE_DOMAIN", "central.hostireland.com");
        define("COOKIE_SECRET_KEY", "1gp@TMPS{+$78sfpMJFe-92s");
        // TODO: adapt the minimum check like in 0-one-file version

        // create/read session
        session_start();

        // check the possible login actions:
        // 1. logout (happen when user clicks logout button)
        // 2. login via session data (happens each time user opens a page on your php project AFTER he has sucessfully logged in via the login form)
        // 3. login via post data, which means simply logging in via the login form. after the user has submit his login/password successfully, his
        //    logged-in-status is written into his session data on the server. this is the typical behaviour of common login scripts.

        // if user tried to log out
        if (isset($_GET["logout"])) {
            $this->doLogout();
        
        }// if user has an active session on the server
        elseif (!empty($_SESSION['user_name']) && ($_SESSION['user_logged_in'] == 1) ) {
            $this->loginWithSessionData();
        }
        // if user just submitted a login form
        elseif (isset($_POST["user_name"])) {
            $this->loginWithPostData();
            
        }// login with cookie
         elseif (isset($_COOKIE['rememberme'])) {
            $this->loginWithCookieData();
         }

    }

    /**
     * log in with session data
     */
    private function loginWithSessionData()
    {
        // set logged in status to true, because we just checked for this:
        // !empty($_SESSION['user_name']) && ($_SESSION['user_logged_in'] == 1)
        // when we called this method (in the constructor)
        $this->user_is_logged_in = true;
    }
    
    /**
    * return password hashed
    */
    
    public function hashpassword($pass){
    return md5($this->salt.$pass);
    
    }

    /**
     * log in with post data
     */
    private function loginWithPostData()
    {
        // if POST data (from login form) contains non-empty user_name and non-empty user_password
        if (!empty($_POST['user_name']) && !empty($_POST['user_password'])) {
        //print_r(md5($this->salt.$_POST['user_password']).' ');

            // create a database connection, using the constants from config/db.php (which we loaded in index.php)
            $this->db_connection = new mysqli('hicritical-cluster.cluster-clhdx2lki42e.eu-west-1.rds.amazonaws.com', 'powercheck',  'buyg867tgf94rn','powercheck');

            // if no connection errors (= working database connection)
            if (!$this->db_connection->connect_errno) {

                // escape the POST stuff
                $this->user_name = $this->db_connection->real_escape_string($_POST['user_name']);
                // database query, getting all the info of the selected user
                $checklogin = $this->db_connection->query("SELECT * FROM dashboard_users WHERE username = '" . $this->user_name . "';");

                // if this user exists
                if ($checklogin->num_rows == 1) {

                    // get result row (as an object)
                    $result_row = $checklogin->fetch_object();

                    // using PHP 5.5's password_verify() function to check if the provided passwords fits to the hash of that user's password
                    $password = md5($this->salt.$this->db_connection->real_escape_string($_POST['user_password']));

                    if ($password==$result_row->password) {						
                        // write user data into PHP SESSION [a file on your server]
                        $_SESSION['user_id'] = $result_row->id;
                        $_SESSION['user_helpdesk_name'] = $result_row->helpdesk_name;
                        $_SESSION['user_name'] = $result_row->username;
                        $_SESSION['user_email'] = $result_row->email;
                        $_SESSION['user_gasecret'] = $result_row->ga_secret;
                        $_SESSION['user_whmcsid'] = $result_row->whmcsid;
                        $_SESSION['user_trelloid'] = $result_row->trelloid;
                        $_SESSION['user_vworkid'] = $result_row->vworkid;
                        $_SESSION['user_logged_in'] = 1;
                        $_SESSION['user_google_auth'] = 0;
                        $_SESSION['password_reset_required'] = $result_row->passwordresetrequired;

                        // set the login status to true
                        $this->user_is_logged_in = true;
                        
                        
                    	if($_POST['user_password'] == true){
                			$this->newRememberMeCookie();
                		}
                		

                    } else {
                        $this->errors[] = "Wrong password. Try again.";
                    }
                } else {
                    $this->errors[] = "This user does not exist.";
                }
            } else {
                $this->errors[] = "Database connection problem.";
            }
        } elseif (empty($_POST['user_name'])) {
            $this->errors[] = "Username field was empty.";
        } elseif (empty($_POST['user_password'])) {
            $this->errors[] = "Password field was empty.";
        }
    }

    /**
     * perform the logout
     */
    public function doLogout()
    {
        $_SESSION = array();
        session_destroy();
        $this->user_is_logged_in = false;
        $this->messages[] = "You have been logged out.";
        print_r($this->messages);
        $this->deleteRememberMeCookie();

    }
    
    ////('localhost', 'powercheck',  'buyg867tgf94rn','powercheck');
    
    
    private function databaseConnection()
    {
        // connection already opened
        if ($this->db_connection != null) {
            return true;
        } else {
            try {
                $this->db_connection = new PDO('mysql:host=hicritical-cluster.cluster-clhdx2lki42e.eu-west-1.rds.amazonaws.com;dbname=powercheck', 'powercheck', 'buyg867tgf94rn');
                return true;
            } catch (PDOException $e) {
                $this->errors[] = $this->lang['Database error'] . $e->getMessage();
                return false;
            }
        }
    }
    
    
    /**
     * Create all data needed for remember me cookie connection on client and server side
     */
    private function newRememberMeCookie()
    {
        // if database connection opened
        // create a database connection, using the constants from config/db.php (which we loaded in index.php)
        $this->db_connection = new mysqli('hicritical-cluster.cluster-clhdx2lki42e.eu-west-1.rds.amazonaws.com', 'powercheck',  'buyg867tgf94rn','powercheck');

        // if no connection errors (= working database connection)
            if (!$this->db_connection->connect_errno) {

            // generate 64 char random string and store it in current user data
            $random_token_string = hash('sha256', mt_rand());
            $sth = $this->db_connection->query("UPDATE dashboard_users SET user_rememberme_token = '".$random_token_string."' WHERE id = '".$_SESSION['user_id']."'");
            //$sth->execute(array(':user_rememberme_token' => $random_token_string, ':user_id' => $_SESSION['user_id']));
            print_r($sth);
            // generate cookie string that consists of userid, randomstring and combined hash of both
            $cookie_string_first_part = $_SESSION['user_id'] . ':' . $random_token_string;
            $cookie_string_hash = hash('sha256', $cookie_string_first_part . COOKIE_SECRET_KEY);
            $cookie_string = $cookie_string_first_part . ':' . $cookie_string_hash;

            // set cookie
            setcookie('rememberme', $cookie_string, time() + COOKIE_RUNTIME, "/", COOKIE_DOMAIN);
            
        }
    }
    
    /**
     * Delete all data needed for remember me cookie connection on client and server side
     */
    private function deleteRememberMeCookie()
    {
        /*
        // if database connection opened
        // create a database connection, using the constants from config/db.php (which we loaded in index.php)
        //$this->db_connection = new mysqli('localhost', 'powercheck',  'buyg867tgf94rn','powercheck');

        // if no connection errors (= working database connection)
        if (!$this->db_connection->connect_errno) {

            // Reset rememberme token
            $sth = $this->db_connection->query("UPDATE dashboard_users SET user_rememberme_token = NULL WHERE id = '".$_SESSION['user_id']."'");
            //$sth->execute(array(':user_id' => $_SESSION['user_id']));
        }

        // set the rememberme-cookie to ten years ago (3600sec * 365 days * 10).
        // that's obivously the best practice to kill a cookie via php
        // @see http://stackoverflow.com/a/686166/1114320
        setcookie('rememberme', false, time() - (3600 * 3650), '/', COOKIE_DOMAIN);
        */
    }

    /**
     * Search into database for the user data of user_name specified as parameter
     * @return user data as an object if existing user
     * @return false if user_name is not found in the database
     * TODO: @devplanete This returns two different types. Maybe this is valid, but it feels bad. We should rework this.
     * TODO: @devplanete After some resarch I'm VERY sure that this is not good coding style! Please fix this.
     
     */
    private function getUserData($user_name)
    {
        // if database connection opened
        if ($this->databaseConnection()) {
            // database query, getting all the info of the selected user
            $query_user = $this->db_connection->prepare('SELECT * FROM dashboard_users WHERE username = :user_name');
            $query_user->bindValue(':user_name', $user_name, PDO::PARAM_STR);
            $query_user->execute();
            // get result row (as an object)
            return $query_user->fetchObject();
        } else {
            return false;
        }
    }
    
    
	/**
     * Edit the user's password, provided in the editing form
     */
    public function editUserPassword($user_password_old, $user_password_new, $user_password_repeat)
    {
        if (empty($user_password_new) || empty($user_password_repeat) || empty($user_password_old)) {
            $this->errors[] = 'Empty password';
        // is the repeat password identical to password
        } elseif ($user_password_new !== $user_password_repeat) {
            $this->errors[] = 'Bad confirm password';
        // password need to have a minimum length of 6 characters
        } elseif (strlen($user_password_new) < 6) {
            $this->errors[] = 'Password too short';


					/*
					 $password = md5($this->salt.$this->db_connection->real_escape_string($_POST['user_password']));
                    
                    if ($password==$result_row->password) {
                    
                    */
                    
                    
                    
        // all the above tests are ok
        } else {
            // database query, getting hash of currently logged in user (to check with just provided password)
            $result_row = $this->getUserData($_SESSION['user_name']);

            // if this user exists
            if (isset($result_row->password)) {

                // using PHP 5.5's password_verify() function to check if the provided passwords fits to the hash of that user's password
                //echo 'old'.$user_password_old.' olddb'. $result_row->password;
                if ($this->hashpassword($user_password_old) == $result_row->password) {


                    //$user_password_hash = password_hash($user_password_new, PASSWORD_DEFAULT, array('cost' => $hash_cost_factor));
                    $user_password_hash = $this->hashpassword($user_password_new);

                    // write users new hash into database
                    $query_update = $this->db_connection->prepare('UPDATE dashboard_users SET `password` = :user_password_hash , `passwordresetrequired`="0" WHERE id = :user_id');
                    $query_update->bindValue(':user_password_hash', $user_password_hash, PDO::PARAM_STR);
                    $query_update->bindValue(':user_id', $_SESSION['user_id'], PDO::PARAM_INT);
                    $query_update->execute();

                    // check if exactly one row was successfully changed:
                    if ($query_update->rowCount()) {
                        $this->messages[] = 'Password changed';
                    } else {
                        $this->errors[] = 'Password changed failed';
                    }
                } else {
                    $this->errors[] = 'Wrong old password';
                }
            } else {
                $this->errors[] = 'User not exist';
            }
        }
    }
    
     /**
     * updates google apps secret
     */
    
    public function updateUserGaSecret($secret)
    {
        if (empty($secret)) {
            $this->errors[] = 'Empty secret';
                    
        // above test is ok
        } else {
            // database query, user details
            $result_row = $this->getUserData($_SESSION['user_name']);

            // if this user exists
            if (isset($result_row->password)) {


                    // write users new hash into database
                    $query_update = $this->db_connection->prepare('UPDATE dashboard_users SET `ga_secret` = :user_ga  WHERE id = :user_id');
                    $query_update->bindValue(':user_ga', $secret, PDO::PARAM_STR);
                    $query_update->bindValue(':user_id', $_SESSION['user_id'], PDO::PARAM_INT);
                    $query_update->execute();

                    // check if exactly one row was successfully changed:
                    if ($query_update->rowCount()) {
                        $this->messages[] = 'Google Auth Updated';
                    } else {
                        $this->errors[] = 'Google Auth Update failed';
                    }
                
            } else {
                $this->errors[] = 'User not exist';
            }
        }
    }

	/**
     * Logs in via the Cookie
     * @return bool success state of cookie login
     */
    private function loginWithCookieData()
    {
        if (isset($_COOKIE['rememberme'])) {
            // extract data from the cookie
            list ($user_id, $token, $hash) = explode(':', $_COOKIE['rememberme']);
            // check cookie hash validity
            if ($hash == hash('sha256', $user_id . ':' . $token . COOKIE_SECRET_KEY) && !empty($token)) {
                // cookie looks good, try to select corresponding user
                if ($this->databaseConnection()) {
                    // get real token from database (and all other data)
                    $sth = $this->db_connection->prepare("SELECT * FROM powercheck.dashboard_users WHERE id = :user_id
                                                      AND user_rememberme_token = :user_rememberme_token AND user_rememberme_token IS NOT NULL");
                    $sth->bindValue(':user_id', $user_id, PDO::PARAM_INT);
                    $sth->bindValue(':user_rememberme_token', $token, PDO::PARAM_STR);
                    $sth->execute();
                    // get result row (as an object)
                    $result_row = $sth->fetchObject();

                    if (isset($result_row->user_id)) {
                        // write user data into PHP SESSION [a file on your server]
                        $_SESSION['user_id'] = $result_row->id;
                        $_SESSION['user_helpdesk_name'] = $result_row->helpdesk_name;
                        $_SESSION['user_name'] = $result_row->username;
                        $_SESSION['user_email'] = $result_row->email;
                        $_SESSION['user_gasecret'] = $result_row->ga_secret;
                        $_SESSION['user_whmcsid'] = $result_row->whmcsid;
                        $_SESSION['user_trelloid'] = $result_row->trelloid;
                        $_SESSION['user_vworkid'] = $result_row->vworkid;
                        $_SESSION['user_logged_in'] = 1;
                        $_SESSION['user_google_auth'] = 0;
                        $_SESSION['password_reset_required'] = $result_row->passwordresetrequired;

                        // declare user id, set the login status to true
                        $this->user_id = $result_row->user_id;
                        $this->user_name = $result_row->user_name;
                        $this->user_email = $result_row->user_email;
                        $this->user_is_logged_in = true;

                        // Cookie token usable only once
                        $this->newRememberMeCookie();
                        return true;
                    }
                }
            }
            // A cookie has been used but is not valid... we delete it
            $this->deleteRememberMeCookie();
            $this->errors[] = 'Invalid cookie';
        }
        return false;
    }


    /**
     * simply return the current state of the user's login
     * @return boolean user's login status
     */
    public function isUserLoggedIn()
    {
        return $this->user_is_logged_in;
    }

    public function getGravatarImageUrl($email, $s = 50, $d = 'mm', $r = 'g', $atts = array() )
    {
        $url = 'http://www.gravatar.com/avatar/';
        $url .= md5(strtolower(trim($email)));
        $url .= "?s=$s&d=$d&r=$r&f=y";

        // the image url (on gravatarr servers), will return in something like
        // http://www.gravatar.com/avatar/205e460b479e2e5b48aec07710c08d50?s=80&d=mm&r=g
        // note: the url does NOT have something like .jpg
        $this->user_gravatar_image_url = $url;

        // build img tag around
        $url = '<img src="' . $url . '"';
        foreach ($atts as $key => $val)
            $url .= ' ' . $key . '="' . $val . '"';
        $url .= ' />';

        // the image url like above but with an additional <img src .. /> around
        $this->user_gravatar_image_tag = $url;
    }


}