<?php

function GenerateSignature($loginPassword, $usrRequest)
{
    $usrLogTime = gmdate('Ymwdhis');
    $loginType = 2;
    $sessionID = session_id();
    if($sessionID == '')
    {
        session_start();
        $sessionID = session_id();
    }
    $passwordOne = md5($loginPassword).$usrLogTime;
    $passwordTwo = md5(md5($loginPassword)).$usrLogTime;
    $signatureOne = SGHashHmac('sha1', $usrRequest, $passwordOne);
    $signatureTwo = SGHashHmac('sha1', $usrRequest, $passwordTwo);
    return array($usrLogTime, $loginType, $signatureOne, $signatureTwo);
	
	
}

function GeneratePostFields($KeyValuePair=array())
{
    $toRet = '';
    foreach ($KeyValuePair as $k => $v) {
        $v = urlencode($v);
        $toRet = $toRet."&".$k."=".$v;
    }
    $toRet = substr($toRet, 1);
    return $toRet;
}

function SGHashHmac($algo, $data, $key, $rawOutput=false)
{
    $phpVersion = PHP_VERSION;
    if($phpVersion[0] == '5' || function_exists('hash_hmac'))
    {
        return hash_hmac($algo, $data, $key);
    }
    else
    {
        return SGHmacGenerator($algo, $data, $key, $rawOutput);
    }
}

function SGHmacGenerator($algo, $data, $key, $rawOutput=false)
{
    //It's only usable with MD5 and SHA1 encryption algorithms - to support PHP4
    $algo = strtolower($algo);
    $pack = 'H'.strlen($algo('test'));
    $size = 64;
    $opad = str_repeat(chr(0x5C), $size);
    $ipad = str_repeat(chr(0x36), $size);

    if (strlen($key) > $size) {
        $key = str_pad(pack($pack, $algo($key)), $size, chr(0x00));
    } else {
        $key = str_pad($key, $size, chr(0x00));
    }

    for ($i = 0; $i < strlen($key) - 1; $i++) {
        $opad[$i] = $opad[$i] ^ $key[$i];
        $ipad[$i] = $ipad[$i] ^ $key[$i];
    }

    $output = $algo($opad.pack($pack, $algo($ipad.$data)));

    return ($rawOutput) ? pack($pack, $output) : $output;
}

function CurlHandling($url, $postFields)
{
    $curl_handle=curl_init();
    curl_setopt($curl_handle, CURLOPT_URL, $url);
    curl_setopt($curl_handle, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($curl_handle, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($curl_handle, CURLOPT_TIMEOUT, 33);
    curl_setopt($curl_handle, CURLOPT_RETURNTRANSFER,1);
    curl_setopt($curl_handle, CURLOPT_POSTFIELDS, $postFields);
    $response = curl_exec($curl_handle);
    if(curl_errno($curl_handle)){
        $response = curl_error($curl_handle);
    }
    curl_close($curl_handle);
    return $response;
}







//http://localhost:6060/?&Action=ListClientInformation&ResellerName=Default Reseller&CustomerName=Default CustomerSam
$action = "GetResellerInfoReport"; //API Action
$action = "ListClientInformation"; //API Action


$token = GenerateSignature("zaq!23EDC", $action); // webconsole pwd
$myArray = array('UserName'=>"admin", "Signature1"=>$token[2], "Signature2"=>$token[3], "SignatureVersion"=>$token[1], "LoginTime"=>$token[0], "Action"=>$action); //webconsole username






//$sendVariables = array('From' => 0 , 'ResultSize' => 5);

// $sendVariables = array('BackupName'=>'First_Backup','ClientName'=> 'arunclient');


 // $sendVariables = array('From'=>0,
                         // 'ResultSize'=>10);

 $sendVariables = array('ResellerName'=>'Default Reseller',
                        'CustomerName'=>'HI Servers',
                         'From'=>0,
                         'ResultSize'=>40);



$newArray = array_merge($myArray , $sendVariables ); //change

$postFields =  GeneratePostFields($newArray);
//print_r($postFields);
$response = CurlHandling("https://backup10.hostireland.com:6061/sgwebservice.php",$postFields); //change
//echo '<pre>';

$xml = json_decode(json_encode((array) simplexml_load_string($response)), 1);
echo '<pre>';

///////////////////////////
///////////////////////////
$servers = $xml['ClientInformation']['Client'];


foreach( $servers as $server){

    $serverclean = $server['@attributes'];
    $ClientName= (string)$serverclean['ClientName'];
    
    print_r($ClientName);
    echo '
    ';

    
}

//// Above works fine
/// Below does not.
/*
            $actionnew = "ListBackups"; //API Action
            $tokennew = GenerateSignature("zaq!23EDC", $actionnew); // webconsole pwd
            $myArraynew = array('UserName'=>"admin", "Signature1"=>$tokennew[2], "Signature2"=>$tokennew[3], "SignatureVersion"=>$tokennew[1], "LoginTime"=>$tokennew[0], "Action"=>$actionnew); //webconsole username

            $sendVariablesnew = array('ClientName'=>'bono.hostireland.com','From'=>1,'ResultSize'=>5);
            $newArraynew = array_merge($myArraynew , $sendVariablesnew ); //change
            echo '
            ';
            $postFieldsnew =  GeneratePostFields($newArraynew);
            echo "************** <BR>";
            print_r($postFieldsnew);
            echo "************** <BR>";
            
            $responsenew = CurlHandling("https://backup10.hostireland.com:6061/sgwebservice.php",$postFieldsnew); //change
            print_r($responsenew);
            
            $backuplist = json_decode(json_encode((array) simplexml_load_string($responsenew)), 1);
            print_r($backuplist);
            
            */
            
            //?Action=AdvancedReport&selectedServerName=(local)&BackupName=local1
            //http://localhost:6060/?Action=DoReports&selectedServerName=ec2­174­129­11­178.compute­1.amazonaws.com&BackupName=test&FullBackupID=0
            
/*
            
            $action = "DoReports"; //API Action
            $token = GenerateSignature("zaq!23EDC", $action); // webconsole pwd
            $myArray = array('UserName'=>"admin", "Signature1"=>$token[2], "Signature2"=>$token[3], "SignatureVersion"=>$token[1], "LoginTime"=>$token[0], "Action"=>$action); //webconsole username

            $sendVariables = array('selectedServerName'=>'stresa.hostireland.com', 'BackupName'=>'stresa_home');
            $newArray = array_merge($myArray , $sendVariables ); //change
            $postFields =  GeneratePostFields($newArray);
                        echo "<BR> ************** <BR>";
            print_r($postFields);
            echo "<BR> ************** <BR>";
            
            $response = CurlHandling("https://stresa.hostireland.com:6061/sgwebservice.php",$postFields); //change
            print_r($response);
*/
?>