<?php
function workTime($start, $end){ 

	/*	Adjust End Time	*/	

	//If the end time is not a weekday, move it to the end of last week.

	$endDayOfWeek = date('w', $end);

	if($endDayOfWeek == 0 || $endDayOfWeek == 6){

		$end = strtotime('Last Friday 5:30pm', $end);

	} 

	//If the ending hour is outside the work range of 9am-5pm, move it to the acceptable time

	$hour = date('H', $end);

	if($hour < 9){

		//the previous dat at 5pm

		$end = strtotime('-1day 5:30pm', $end);

	}

	if($hour > 17){

		//Today at 5pm

		$end = strtotime('5:30pm', $end);

	}

	

	/*	Adjust Start Time	*/

	//If the start time is not a weekday, move it to the start of next week.

	$startDayOfWeek = date('w', $start);

	if($startDayOfWeek == 0 || $startDayOfWeek == 6){

		$start = strtotime('Next Monday 8:30am', $start);

	} 

	//If the starting hour is outside the work range of 9am-5pm, move it to the acceptable time

	$hour = date('H', $start);

	if($hour < 9){

		//same day at 9am

		$start = strtotime('8:30am', $start);

	}

	if($hour > 17){

		//next day at 9am

		$start = strtotime('+1day 8:30am', $start);

	}

	

	/*	Calculate Difference	*/

	if(date('Y-m-d', $start) == date('Y-m-d', $end)){

		//The dates are the same day and have been adjusted to be within 9am-5pm, just subtract the times. 

		$seconds = $end-$start;

	}else{

		//How many days (rounding down) are between the start time and the new edited end time?

		$daysBetween = floor(($end-$start)/(60*60*24));

		

		$day = $startDayOfWeek; //We need to track what day of the week we are adding hours for, so we can skip weekends.

		

		//The seconds for the first day from work started until the end of the day at 5pm

		$seconds = strtotime('5pm', $start)-$start;

		

		//The rest of the days

		for($i=1; $i<$daysBetween; $i++){

			$day++; //Add a day

			if($day > 6){ //If it's greater than 6 roll back to 0. 

				$day = 0;

			}

			//If it's not a weekend

			if($day > 0 && $day < 6){

				$seconds+=(60*60*8); //Add 8 hours worth of seconds.

			}

		}

	

		//Add the last day's worth of work.

		$seconds += $end-strtotime('8:30am', $end);

	}

	return $seconds;	

}

echo workTime('1391129055', '1395231544');