<?php
echo '<pre>';

function checkBackupStatus($backup){
    return 'CustomSuccess';
}

function GenerateSignature($loginPassword, $usrRequest)
{
    $usrLogTime = gmdate('Ymwdhis');
    $loginType = 2;
    $sessionID = session_id();
    if($sessionID == '')
    {
        session_start();
        $sessionID = session_id();
    }
    $passwordOne = md5($loginPassword).$usrLogTime;
    $passwordTwo = md5(md5($loginPassword)).$usrLogTime;
    $signatureOne = SGHashHmac('sha1', $usrRequest, $passwordOne);
    $signatureTwo = SGHashHmac('sha1', $usrRequest, $passwordTwo);
    return array($usrLogTime, $loginType, $signatureOne, $signatureTwo);
	
	
}

function GeneratePostFields($KeyValuePair=array())
{
    $toRet = '';
    foreach ($KeyValuePair as $k => $v) {
        $v = urlencode($v);
        $toRet = $toRet."&".$k."=".$v;
    }
    $toRet = substr($toRet, 1);
    return $toRet;
}

function SGHashHmac($algo, $data, $key, $rawOutput=false)
{
    $phpVersion = PHP_VERSION;
    if($phpVersion[0] == '5' || function_exists('hash_hmac'))
    {
        return hash_hmac($algo, $data, $key);
    }
    else
    {
        return SGHmacGenerator($algo, $data, $key, $rawOutput);
    }
}

function SGHmacGenerator($algo, $data, $key, $rawOutput=false)
{
    //It's only usable with MD5 and SHA1 encryption algorithms - to support PHP4
    $algo = strtolower($algo);
    $pack = 'H'.strlen($algo('test'));
    $size = 64;
    $opad = str_repeat(chr(0x5C), $size);
    $ipad = str_repeat(chr(0x36), $size);

    if (strlen($key) > $size) {
        $key = str_pad(pack($pack, $algo($key)), $size, chr(0x00));
    } else {
        $key = str_pad($key, $size, chr(0x00));
    }

    for ($i = 0; $i < strlen($key) - 1; $i++) {
        $opad[$i] = $opad[$i] ^ $key[$i];
        $ipad[$i] = $ipad[$i] ^ $key[$i];
    }

    $output = $algo($opad.pack($pack, $algo($ipad.$data)));

    return ($rawOutput) ? pack($pack, $output) : $output;
}

function CurlHandling($url, $postFields)
{
    $curl_handle=curl_init();
    curl_setopt($curl_handle, CURLOPT_URL, $url);
    curl_setopt($curl_handle, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($curl_handle, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($curl_handle, CURLOPT_TIMEOUT, 33);
    curl_setopt($curl_handle, CURLOPT_RETURNTRANSFER,1);
    curl_setopt($curl_handle, CURLOPT_POSTFIELDS, $postFields);
    $response = curl_exec($curl_handle);
    if(curl_errno($curl_handle)){
        $response = curl_error($curl_handle);
    }
    curl_close($curl_handle);
    return $response;
}







$action = "GetResellerInfoReport"; //API Action
$action = "ListClientInformation"; //API Action


$token = GenerateSignature("zaq!23EDC", $action); // webconsole pwd
$myArray = array('UserName'=>"admin", "Signature1"=>$token[2], "Signature2"=>$token[3], "SignatureVersion"=>$token[1], "LoginTime"=>$token[0], "Action"=>$action); //webconsole username

$sendVariables = array('ResellerName'=>'Default Reseller', 'CustomerName'=>'HI Servers', 'From'=>0, 'ResultSize'=>40);

$newArray = array_merge($myArray , $sendVariables ); //change

$postFields =  GeneratePostFields($newArray);

$response = CurlHandling("https://backup10.hostireland.com:6061/sgwebservice.php",$postFields); //change


$xml = json_decode(json_encode((array) simplexml_load_string($response)), 1);


///////////////////////////
///////////////////////////
$servers = $xml['ClientInformation']['Client'];


foreach( $servers as $server){

    $serverclean = $server['@attributes'];
    $ClientName= (string)$serverclean['ClientName'];
        
        //print_r($ClientName);
       // echo '
      //  ';
        //if($ClientName == 'stresa.hostireland.com'){
                
            
    $action = "ListBackups"; //API Action
    $clientName = $ClientName;
    
    $token = GenerateSignature("zaq!23EDC", $action); // webconsole pwd
    $myArray = array('UserName'=>"admin", "Signature1"=>$token[2], "Signature2"=>$token[3], "SignatureVersion"=>$token[1], "LoginTime"=>$token[0], "Action"=>$action, "ClientName"=>$ClientName); //webconsole username
    
    $sendVariables = array('From' => 0 , 'ResultSize' => 5);
    
    $newArray = array_merge($myArray , $sendVariables ); //change
    
    $postFields =  GeneratePostFields($newArray);
    
    $response = CurlHandling("https://backup10.hostireland.com:6061/sgwebservice.php",$postFields); //change
    $explodedresponse=explode('<?xml version="1.0" ?>', $response);

    $xml = json_decode(json_encode((array) simplexml_load_string($explodedresponse[1])), 1);
    $backups = $xml['GroupConfiguration']['ListGroup']['Group'];

    $i=1;
    $count=count($backups);
    if($count ==1){
        if($backups['@attributes']['GroupName'] != 'METADATA_BACKUP'){
            $backuplist[$clientName][$backups['@attributes']['GroupName']]['jobname']= $backups['@attributes']['GroupName'];
        }
    } else {
        foreach($backups as $backup){
            if($backup['@attributes']['GroupName'] != 'METADATA_BACKUP'){
                $backuplist[$clientName][$backup['@attributes']['GroupName']]['jobname']= $backup['@attributes']['GroupName'];
                $i++;
            }
        }
    }
   
} // end foreach servers



///////////////////////
///////////////////////
/* $backuplist
Array
(
    [aircontrol2] => Array
        (
            [1] => AirControl_Backup
            [2] => METADATA_BACKUP
        )

    [bono.hostireland.com] => Array
        (
            [1] => bono_home_daily_backup
            [2] => etc_directory_bono
            [3] => METADATA_BACKUP
        )

*/

///////////////////////
///////////////////////


foreach($backuplist as $clientnamekey=>$clientcheck){
    foreach($clientcheck as $key=>$backupname){
        
        if($key !='METADATA_BACKUP'){
            $action = "GenerateClientBackupStatusReport"; //API Action
            $clientName = $clientnamekey;
            $backupname=$key;
            
            $token = GenerateSignature("zaq!23EDC", $action); // webconsole pwd
            $myArray = array('UserName'=>"admin", "Signature1"=>$token[2], "Signature2"=>$token[3], "SignatureVersion"=>$token[1], 
            "LoginTime"=>$token[0], "Action"=>$action, "ClientName"=>$clientName, "BackupName"=>$backupname, 
            "backupStatus"=>1, "IncludeFailedStatus"=>1, "IncludeMissedStatus"=>1, "IncludePartialStatus"=>1,
            "IncludeSuccessStatus"=>1, "TimeStatus"=>1 ); //webconsole username
            
            $sendVariables = array('From' => 0 , 'ResultSize' => 35);
            
            $newArray = array_merge($myArray , $sendVariables ); //change
            
            $postFields =  GeneratePostFields($newArray);
            
            $response = CurlHandling("https://backup10.hostireland.com:6061/sgwebservice.php",$postFields); //change
            //print_r(htmlentities($response));
            
            $explodedresponse=explode('<?xml version="1.0"?>', $response);
            $xml = json_decode(json_encode((array) simplexml_load_string($explodedresponse[1])), 1);

            $exactbackups = array ();
            $i=1;
            $statusreports = $xml['SinglePageReport']['CustomerDetails'];
            $count = count($statusreports);
            if($count >1){
                foreach ($xml['SinglePageReport']['CustomerDetails'] as $backupstatus){
                    if($backupstatus['@attributes']['BackupName'] == $backupname && $i <4){
                        $exactbackups[$i]=$backupstatus['@attributes'];
                        
                        $i++;
                    }
                }
            }else{
                
                $exactbackups[1]=$xml['SinglePageReport']['CustomerDetails']['@attributes'];
            
            }
            //print_r($exactbackups);
            
            $backuplist[$clientName][$backupname]['status']=$exactbackups;
            
        }
    }
    
}



////

////

/*
Array
(
    [aircontrol2] => Array
        (
            [AirControl_Backup] => Array
                (
                    [jobname] => AirControl_Backup
                    [status] => Array
                        (
                            [1] => Array
                                (
                                    [Name] => HI Servers
                                    [ResellerName] => Default Reseller
                                    [ClientName] => aircontrol2
                                    [BackupName] => AirControl_Backup
                                    [PluginType] => 0
                                    [ScheduleType] => 1
                                    [LastScheduleStartTime] => 1395574211
                                    [LastScheduleEndTime] => 1395574551
                                    [NextScheduleTime] => 1396179001
                                    [NoOfAttempts] => 1
                                    [Remarks] => Success
                                    [Status] => 1
                                    [ReportStatusToUI] => 5
                                    [TotalFiles] => 22
                                    [ProtectedFiles] => 22
                                    [SkippedFiles] => 0
                                    [SkippedFolders] => 0
                                )

                        )

                )

        )

*/

echo 'Backup Checks: <br>';
foreach ($backuplist as $server){
    $headerdone=0;
    
    foreach($server as $backup){
            
        foreach($backup['status'] as $backupstatus){
            if( $backupstatus['Status'] == 1){ 
                $status = 'Success'; 
                $date =  date("Y-m-d", $backupstatus['LastScheduleEndTime']);
                $extratext = $date;
                if($backupstatus['LastScheduleEndTime'] > (time()-(60*60*48))){
                    $colour = 'green'; 
                } else {
                    $colour = 'orange';
                }
                
            }else if($backupstatus['Status'] ==10 ){
                $date =  date("Y-m-d", $backupstatus['LastScheduleStartTime']);
                $extratext = $backupstatus['Remarks'].' '.$date;
                $colour = 'green';
            }else if($backupstatus['Status'] ==11){
                $date =  date("Y-m-d", $backupstatus['LastScheduleStartTime']);
                $extratext = 'Missed '.$date;
                $colour = 'orange';
            }else if($backupstatus['Status'] == '16'&& $backupstatus['ProtectedFiles'] > '0' ){
                $date =  date("Y-m-d", $backupstatus['LastScheduleEndTime']);
                $extratext = 'Partial '.$date;
                $colour = 'orange';
            
            }else if($backupstatus['Status'] == '16'&& $backupstatus['ProtectedFiles'] > '0' && $backupstatus['LastScheduleEndTime'] > (time()-(60*60*48)) ){
                $date =  date("Y-m-d", $backupstatus['LastScheduleEndTime']);
                $extratext = 'Partial '.$date;
                $colour = 'green';
            
            }else if ($backupstatus['Status'] == 53){
                $date =  date("Y-m-d", $backupstatus['LastScheduleEndTime']);
                $extratext = $backupstatus['Remarks'].' '.$date; // possibly stuck
                $colour = 'blue';
            }else{ 
                $date =  date("Y-m-d", $backupstatus['LastScheduleEndTime']);
                $extratext = $backupstatus['Remarks'].$date;
                $colour = 'red';
            }
            
            echo '<span style="color: '.$colour.';">'.$backupstatus['ClientName']. ' - '.$backupstatus['BackupName'].' - '.$extratext.'</span><br>';

        }// end of foreach status
    }
}
echo '<br><br>';
print_r($backuplist);
?>