<?php

function GenerateSignature($loginPassword, $usrRequest)
{
    $usrLogTime = gmdate('Ymwdhis');
    $loginType = 2;
    $sessionID = session_id();
    if($sessionID == '')
    {
        session_start();
        $sessionID = session_id();
    }
    $passwordOne = md5($loginPassword).$usrLogTime;
    $passwordTwo = md5(md5($loginPassword)).$usrLogTime;
    $signatureOne = SGHashHmac('sha1', $usrRequest, $passwordOne);
    $signatureTwo = SGHashHmac('sha1', $usrRequest, $passwordTwo);
    return array($usrLogTime, $loginType, $signatureOne, $signatureTwo);
	
	
}

function GeneratePostFields($KeyValuePair=array())
{
    $toRet = '';
    foreach ($KeyValuePair as $k => $v) {
        $v = urlencode($v);
        $toRet = $toRet."&".$k."=".$v;
    }
    $toRet = substr($toRet, 1);
    return $toRet;
}

function SGHashHmac($algo, $data, $key, $rawOutput=false)
{
    $phpVersion = PHP_VERSION;
    if($phpVersion[0] == '5' || function_exists('hash_hmac'))
    {
        return hash_hmac($algo, $data, $key);
    }
    else
    {
        return SGHmacGenerator($algo, $data, $key, $rawOutput);
    }
}

function SGHmacGenerator($algo, $data, $key, $rawOutput=false)
{
    //It's only usable with MD5 and SHA1 encryption algorithms - to support PHP4
    $algo = strtolower($algo);
    $pack = 'H'.strlen($algo('test'));
    $size = 64;
    $opad = str_repeat(chr(0x5C), $size);
    $ipad = str_repeat(chr(0x36), $size);

    if (strlen($key) > $size) {
        $key = str_pad(pack($pack, $algo($key)), $size, chr(0x00));
    } else {
        $key = str_pad($key, $size, chr(0x00));
    }

    for ($i = 0; $i < strlen($key) - 1; $i++) {
        $opad[$i] = $opad[$i] ^ $key[$i];
        $ipad[$i] = $ipad[$i] ^ $key[$i];
    }

    $output = $algo($opad.pack($pack, $algo($ipad.$data)));

    return ($rawOutput) ? pack($pack, $output) : $output;
}

function CurlHandling($url, $postFields)
{
    $curl_handle=curl_init();
    curl_setopt($curl_handle, CURLOPT_URL, $url);
    curl_setopt($curl_handle, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($curl_handle, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($curl_handle, CURLOPT_TIMEOUT, 33);
    curl_setopt($curl_handle, CURLOPT_RETURNTRANSFER,1);
    curl_setopt($curl_handle, CURLOPT_POSTFIELDS, $postFields);
    $response = curl_exec($curl_handle);
    if(curl_errno($curl_handle)){
        $response = curl_error($curl_handle);
    }
    curl_close($curl_handle);
    return $response;
}

/*
Action=GenerateClientBackupStatusReport
&ClientName=stresa.hostireland.com
&BackupName=stresa_home
&From=0
&ResultSize=5
&backupStatus=1
&IncludeFailedStatus=1
&IncludeMissedStatus=1
&IncludePartialStatus=1
&IncludeSuccessStatus=1
&TimeStatus=1
*/
$action = "GenerateClientBackupStatusReport"; //API Action
$clientName = "stresa.hostireland.com";
$backupname="stresa_home";

$token = GenerateSignature("zaq!23EDC", $action); // webconsole pwd
$myArray = array('UserName'=>"admin", "Signature1"=>$token[2], "Signature2"=>$token[3], "SignatureVersion"=>$token[1], 
"LoginTime"=>$token[0], "Action"=>$action, "ClientName"=>$clientName, "BackupName"=>$backupname, 
"backupStatus"=>1, "IncludeFailedStatus"=>1, "IncludeMissedStatus"=>1, "IncludePartialStatus"=>1,
"IncludeSuccessStatus"=>1, "TimeStatus"=>1 ); //webconsole username

$sendVariables = array('From' => 0 , 'ResultSize' => 20);

$newArray = array_merge($myArray , $sendVariables ); //change

$postFields =  GeneratePostFields($newArray);

$response = CurlHandling("https://backup10.hostireland.com:6061/sgwebservice.php",$postFields); //change
//print_r(htmlentities($response));

$explodedresponse=explode('<?xml version="1.0"?>', $response);
$xml = json_decode(json_encode((array) simplexml_load_string($explodedresponse[1])), 1);
echo '<pre>';
$exactbackups = array ();
$i=1;
foreach ($xml['SinglePageReport']['CustomerDetails'] as $backupstatus){
    if($backupstatus['@attributes']['BackupName'] == $backupname && $i <4){
        $exactbackups[$i]=$backupstatus['@attributes'];
        $i++;
    }
}
print_r($exactbackups);


?>